"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.settingsFactory = void 0;
var settingsValidation_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation");
var runtime_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/runtime");
var builtinLogger_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/logger/builtinLogger");
var consent_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/consent");
var browser_1 = require("./defaults/browser");
var browser_2 = require("./storage/browser");
var params = {
    defaults: browser_1.defaults,
    acceptKey: true,
    runtime: runtime_1.validateRuntime,
    storage: browser_2.validateStorage,
    logger: builtinLogger_1.validateLogger,
    consent: consent_1.validateConsent,
};
function settingsFactory(config) {
    return (0, settingsValidation_1.settingsValidation)(config, params);
}
exports.settingsFactory = settingsFactory;
