"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.settingsFactory = void 0;
var settingsValidation_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation");
var builtinLogger_1 = require("@splitsoftware/splitio-commons/cjs/utils/settingsValidation/logger/builtinLogger");
var node_1 = require("./defaults/node");
var node_2 = require("./storage/node");
var node_3 = require("./runtime/node");
var params = {
    defaults: node_1.defaults,
    runtime: node_3.validateRuntime,
    storage: node_2.validateStorage,
    logger: builtinLogger_1.validateLogger,
};
function settingsFactory(config) {
    var settings = (0, settingsValidation_1.settingsValidation)(config, params);
    // if provided, keeps reference to the `requestOptions` object
    if (settings.sync.requestOptions)
        settings.sync.requestOptions = config.sync.requestOptions;
    return settings;
}
exports.settingsFactory = settingsFactory;
